#include <fstream>
#include <string>


const int MaxT = 300000;

struct Triple {
    int i, j, v;
};

void ReadSparseMatrix(int& n, int& m, Triple a[], int&N1,
                      Triple b[], int& N2);
void SumMatrix(Triple a[], int N1, Triple b[], int N2,
               Triple c[], int& N);
void PrintMatrix(Triple a[], int N);
bool Lesser(const Triple& t1, const Triple& t2);
bool Equal(const Triple& t1, const Triple& t2);

Triple a[MaxT];
Triple b[MaxT];
Triple c[2 * MaxT];

int main()
{
    int n, m, N1, N2, N;
    ReadSparseMatrix(n, m, a, N1, b, N2);
    SumMatrix(a, N1, b, N2, c, N);
    PrintMatrix(c, N);
    return 0;
}

void ReadSparseMatrix(int& n, int& m, Triple a[], int&N1,
                      Triple b[], int& N2)
{
    std::ifstream fin("matrice_rara.in");
    fin >> n >> m >> N1 >> N2;
    for (int i = 0; i < N1; ++i)
        fin >> a[i].i >> a[i].j >> a[i].v;

    for (int i = 0; i < N2; ++i)
        fin >> b[i].i >> b[i].j >> b[i].v;

    fin.close();
}

void SumMatrix(Triple a[], int N1, Triple b[], int N2,
               Triple c[], int& N)
{
    int i = 0, j = 0, k = 0;
    while (i < N1 && j < N2)
        if (Lesser(a[i], b[j]))
            c[k++] = a[i++];
        else
            if (Equal(a[i], b[j]))
            {
                c[k] = a[i];
                c[k].v += b[j].v;
                k++, i++, j++;
            }
            else
                c[k++] = b[j++];

    while (j < N2)
        c[k++] = b[j++];
    while (i < N1)
        c[k++] = a[i++];
    N = k;
}

bool Lesser(const Triple& t1, const Triple& t2)
{
    return t1.i < t2.i ||
           (t1.i == t2.i && t1.j < t2.j);
}

bool Equal(const Triple& t1, const Triple& t2)
{
    return t1.i == t2.i && t1.j == t2.j;
}


void PrintMatrix(Triple a[], int N)
{
    std::ofstream fout("matrice_rara.out");
    for (int i = 0; i < N; ++i)
        fout << a[i].i << ' ' << a[i].j << ' '
             << a[i].v << '\n';

    fout.close();
}
